#chat_widget {
    background-color: rgb(var(--movim-background));
    display: flex;
    flex-direction: column;
    overflow: hidden;
}

main:not(.enabled) #chat_widget {
    overflow-y: auto;
}

#chat_explore {
    width: 100%;
}

#chat_widget > div:not(#chat_explore),
#chat_widget > header {
    max-width: 100%;
    width: 100%;
}

#chat_widget > header {
    box-shadow: var(--elevation-1);
    z-index: 1;
}

#chat_widget p.compose:not(.first):not(:empty),
#chat_widget p.compose:not(.first):empty + p {
    animation: fadein 0.3s;
}

#chat_widget p.compose:not(:empty) + p {
    display: none;
}

#chat_widget .contained {
    overflow-y: scroll;
    height: 100%;
}

#chat_widget .contained section {
    max-width: 100rem;
    margin: 0 auto;
}

/* Chat attach list */

#chat_widget ul.list.actions {
    right: -1rem;
    position: absolute;
    bottom: 7rem;
    opacity: 0;
    transform: translateY(5%) scaleY(0.98);
    transition: transform 0.2s, opacity 0.2s;
    pointer-events: none;
}

#chat_widget span.control.enabled + ul.list.actions {
    opacity: 1;
    z-index: 2;
    transform: translateY(0) scaleY(1);
    pointer-events: initial;
}

#chat_widget ul.list.actions > li > div > p {
    border-radius: 0.65rem;
    line-height: 4rem;
    padding: 0 1.25rem;
    font-size: 1.75rem;
    float: right;
}

#chat_widget ul.list.actions > li > span.control,
#chat_widget ul.list.actions > li > div > p {
    transition: box-shadow 0.3s ease, background 0.3s ease;
    box-shadow: var(--elevation-1);
}

#chat_widget ul.list.actions > li > span.control:hover,
#chat_widget ul.list.actions > li > div > p:hover {
    box-shadow: var(--elevation-2);
    background-color: rgba(var(--movim-element-action), 0.1);
}

/* Scroll button */

#chat_widget #scroll_down.button.action {
    animation: none;
    opacity: 0;
    transform: scale(90%);
    position: absolute;
    top: -6.25rem;
    right: 0.75rem;
    pointer-events: none;
}

#chat_widget #scroll_down.button.action.show {
    transition: transform 0.2s ease-in-out, opacity 0.2s;
    transform: scale(100%);
    opacity: 1;
    pointer-events: all;
}

/* Chat box */

#chat_widget .chat_box {
    position: relative;
}

#chat_widget .chat_box ul {
    margin: 0;
    max-width: 100%;
}

#chat_widget .chat_box form > div {
    min-height: 0;
    top: -2rem;
}

#chat_widget .chat_box form textarea {
    padding-top: 0;
    margin-top: 3.5rem;
    margin-bottom: -1rem;
    margin-left: 1rem;
    max-height: 50vh;
    overflow-y: auto;
    width: calc(100% - 1.5rem);
}

#chat_widget .chat_box form textarea ~ span.encrypted,
#chat_widget .chat_box form textarea ~ span.encrypted_disabled,
#chat_widget .chat_box form textarea ~ span.encrypted_loading {
    display: none;
}

#chat_widget .chat_box form textarea ~ span.encrypted_loading {
    opacity: 0.5;
}

#chat_widget .chat_box form textarea[data-encryptedstate="yes"],
#chat_widget .chat_box form textarea[data-encryptedstate="disabled"],
#chat_widget .chat_box form textarea[data-encryptedstate="build"] {
    width: calc(100% - 5.5rem);
}

#chat_widget .chat_box form textarea[data-encryptedstate="yes"] ~ span.control.icon.encrypted,
#chat_widget .chat_box form textarea[data-encryptedstate="disabled"] ~ span.control.icon.encrypted_disabled,
#chat_widget .chat_box form textarea[data-encryptedstate="build"] ~ span.control.icon.encrypted_loading {
    display: inline-block;
    font-size: 2.75rem;
    position: absolute;
    right: 0;
    bottom: -0.6rem;
}

#chat_widget .chat_box span.primary,
#chat_widget .chat_box span.control:not(.button):not(.color) {
    font-size: 3.5rem;
    color: rgba(var(--movim-font), 0.68);
    animation: fadein 0.3s;
}

#chat_widget .chat_box span.primary#record {
    color: rgba(255, 255, 255, 0.9);
}

#chat_widget .chat_box span.control:not(.button) i {
    font-size: inherit;
}

#chat_widget .chat_box span.control:hover {
    cursor: pointer;
}

#chat_widget .chat_box:after {
    position: absolute;
    display: block;
    background-color: rgb(var(--movim-main));
    width: 0;
    height: 0.25rem;
    content: '';
    top: -0.25rem;
    transition: width 5s ease-in-out, opacity 0.2s ease-in-out;
    opacity: 0;
}

#chat_widget .chat_box.sending:after {
    width: 100%;
    opacity: 1;
}

#chat_widget .chat_box.finished:after {
    transition: width 1s cubic-bezier(.68,0,0,1), opacity 1s ease-in-out;
    width: 100%;
    opacity: 0;
}

#chat_widget .chat_box.sending span.control.send {
    animation: loadingopacity 0.7s infinite alternate;
    pointer-events: none;
}

#chat_widget .chat_box > ul.list > li:not(:empty) {
    min-height: 0;
    padding: 0.5rem;
}

#chat_widget .chat_box > ul.list > li form {
    position: relative;
    margin: 0 0.5rem;
    padding: 0;
    padding-right: 0.5rem;
}

#chat_widget .chat_box > ul.list > li form:before {
    content: "";
    display: block;
    width: 100%;
    height: 100%;
    box-shadow: var(--elevation-1);
    background-color: rgba(var(--movim-background-main));
    position: absolute;
    top: 0;
    border-radius: 1rem;
}

#chat_widget .chat_box > ul.list > li > .control {
    transition: transform 0.2s;
}

#chat_widget .chat_box > ul.list > li > .control.attach.enabled {
    transform: rotate(45deg);
}

#chat_widget .chat_box.compose > ul.list > li > ul.list.actions,
#chat_widget .chat_box:not(.compose) > ul.list > li > .control.attach ~ .control.send:not(.emojis),
#chat_widget .chat_box.compose > ul.list > li > .control.attach ~ .control:not(.send):not(.emojis),
#chat_widget .chat_box.compose > ul.list > li > .control:not(.send):not(.emojis) {
    display: none;
}

#chat_widget section > ul.list > li.oppose {
    flex-direction: row-reverse;
}

@media screen and (max-width: 1024px) {
    #chat_widget .chat_box {
        left: 0;
        width: 100%;
    }

    #chat_widget section > ul.list > li.oppose > span.primary {
        display: none;
    }
}

#chat_widget .contained ul {
    overflow-x: hidden;
}

/* Emojis */

#chat_widget .chat_box li.emojis:not(:empty) {
    text-align: center;
    margin-top: 0.25rem;
    max-height: 10.5rem;
    overflow: hidden;
    flex-wrap: wrap;
    justify-content: center;
    border-top: 1px solid rgba(var(--movim-font), 0.12);
}

#chat_widget .chat_box .emojis img {
    display: inline-block;
    padding: 1rem;
    border-radius: 0.25rem;
    margin: 0;
    flex: 0 0 5rem;
    height: 5rem;
    box-sizing: border-box;
}

#chat_widget .chat_box .emojis img:hover,
#chat_widget .chat_box .emojis img.selected {
    cursor: pointer;
    background-color: rgba(var(--movim-font), 0.05);
    padding: 0.5rem;
}

/* Chatroom */

#chat_widget ul.simple {
    padding-left: 2rem;
}

#chat_widget div:not(.chat_box):not(#chat_explore) ul.conversation > li > span.icon {
    align-self: flex-start;
    margin: 0;
}

#chat_widget li img:not(.emoji) {
    max-height: 30rem;
    max-width: 100%;
    display: block;
    width: auto;
}

#chat_widget li img.active {
    transition: opacity 0.1s ease-in-out;
}

#chat_widget li img.active:hover {
    cursor: pointer;
    opacity: 0.6;
}

#chat_widget li img.active:active {
    opacity: 0.8;
}

#chat_widget li img.sticker {
    max-height: 150px;
    border-radius: 0.75rem;
    margin-bottom: 3rem;
}

#chat_widget ul.list:after {
    content: " ";
    display: block;
    clear: both;
}

#chat_widget .contained.muc ul li span.primary:not(:empty):hover {
    cursor: pointer;
}

#chat_widget .contained ul li.sequel > span.icon,
#chat_widget .contained ul li.sequel .bubble::before,
#chat_widget .contained ul li.oppose + li.oppose > span.icon,
#chat_widget .contained ul li.oppose + li.oppose .bubble::before,
#chat_widget .contained:not(.muc) ul li:not(.oppose):not(.separator):not(.date) + li:not(.oppose) > span.icon,
#chat_widget .contained:not(.muc) ul li:not(.oppose):not(.separator):not(.date) + li:not(.oppose) .bubble::before {
    opacity: 0;
    pointer-events: none;
}

#chat_widget .contained section > ul > li {
    animation: fadein 0.2s;
    padding: 0 1rem;
}

#chat_widget ul ~ .placeholder {
    display: none;
}

#chat_widget ul:empty ~ .placeholder.show {
    display: block;
    animation: fadein 1s;
}

#emojisearchbar {
    margin-right: 1rem;
}

#emojisearchbar form div {
    min-height: 7rem;
}

#emojisearchbar form div input {
    padding-top: 2rem;
}

#emojisearchbar ~ .emojis {
    padding: 0 1rem;
    display: grid;
    grid-template-columns: repeat(6, 1fr);
}

#emojisearchbar ~ .emojis.results,
#emojisearchbar ~ .emojis:last-child {
    margin-bottom: 1rem;
}

#emojisearchbar ~ .emojis img {
    text-align: center;
    padding: 1rem 1.5rem;
    font-size: 0;
    position: relative;
}

#emojisearchbar ~ .emojis.main {
    border-bottom: 1px solid rgba(var(--movim-font), 0.12);
    padding-bottom: 0.5rem;
    margin-bottom: 0.5rem;
}

#emojisearchbar ~ .emojis.results:empty,
#emojisearchbar ~ .emojis.results:not(:empty) ~ .emojis {
    display: none;
}

#chat_widget textarea#chat_textarea ~ span.control:hover,
#chat_widget .primary_action:hover,
#emojisearchbar ~ .emojis img:hover {
    cursor: pointer;
    background-color: rgba(var(--movim-font), 0.05);
    border-radius: 0.5rem;
}

#chat_widget div.quoted {
    border-right: 3px solid rgb(var(--movim-main));
    border-radius: 0 3px 3px;
}

/* Parent */

#chat_widget div.parent {
    border-left: 0.25rem solid gray;
    padding: 0 1rem;
}

#chat_widget .bubble div div.parent {
    margin: 0.25rem 0;
}

#chat_widget .bubble div + div div.parent {
    margin-top: 1rem;
}

#chat_widget div.parent[data-parent-id]:hover {
    cursor: pointer;
    background-color: rgba(var(--movim-font), 0.04);
}

#chat_widget div.parent span,
#chat_widget div.parent p {
    font-size: 1.6rem;
    display: block;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    line-height: 2.4rem;
}

#chat_widget .bubble div.parent p {
    color: rgba(var(--movim-font), 0.60);
    white-space: pre-wrap;
}

/* Date element */

li div.bubble:after {
    content: attr(data-publishedprepared);
    line-height: 1.5rem;
    right: 1rem;
    bottom: 1rem;
    position: absolute;
    pointer-events: none;
}

li div.bubble.file:not(.audio):after {
    right: 0;
    bottom: 0.5rem;
}

/* Emojis */

#chat_widget .bubble ul.reactions {
    display: flex;
}

#chat_widget .bubble.file .reactions {
    margin-right: 4.5rem;
    margin-top: -2rem;
}

#chat_widget .bubble div span.reaction,
#chat_widget .bubble div span.reply,
#chat_widget .bubble ul.reactions li {
    list-style-type: none;
    background-color: rgba(var(--movim-background-main), 1);
    color: rgba(var(--movim-font), 0.75);
    padding: 0 0.5rem;
    border-radius: 0.5rem;
    line-height: 3rem;
    font-size: 2rem;
    margin: 0.25rem 0;
    display: inline-flex;
    z-index: 1;
    border: solid 1px transparent;
    box-shadow: var(--elevation-0);
    transition: background-color 0.3s ease;
}

#chat_widget .bubble div span.reaction:hover,
#chat_widget .bubble div span.reply:hover,
#chat_widget .bubble ul.reactions li:hover {
    cursor: pointer;
    background-color: rgba(var(--movim-element-action), 0.1);
    box-shadow: var(--elevation-1);
}

#chat_widget .bubble div span.reaction:active,
#chat_widget .bubble div span.reply:active,
#chat_widget .bubble ul.reactions li:active {
    background-color: rgba(var(--movim-element-action), 0.2);
    box-shadow: var(--elevation-0);
}

#chat_widget .bubble ul.reactions li:not(:last-child) {
    margin-right: 0.5rem;
    font-size: 1.75rem;
}

#chat_widget .bubble ul.reactions li i {
    padding: 0;
}

#chat_widget .bubble > div {
    padding-right: 7rem;
    margin-right: -7rem;
}

#chat_widget .bubble:not(.file) > div:last-child {
    padding-right: 12rem;
}

#chat_widget .bubble div span.reaction,
#chat_widget .bubble div span.reply,
#chat_widget .bubble ul.reactions:empty {
    display: none;
}

@media screen and (min-width: 1025px) {
    #chat_widget li .bubble div:hover ul.reactions:empty ~ span.reaction,
    #chat_widget li .bubble div:not(.encrypted):hover span.reply {
        display: inline-flex;
        position: absolute;
        left: 100%;
        transform: translate(-0.5rem, -0.5rem);
    }

    #chat_widget li .bubble.file div:hover ul.reactions:empty ~ span.reaction,
    #chat_widget li .bubble.file div:not(.encrypted):hover span.reply {
        transform: translate(-0.5rem, -5.5rem);
    }

    #chat_widget li .bubble div:hover ul.reactions:not(:empty) ~ span.reply {
        margin-top: -3rem;
    }

    #chat_widget li .bubble div:hover ul.reactions:empty ~ span.reaction ~ span.reply {
        left: calc(100% + 3.5rem);
    }
}

#chat_widget .bubble ul.reactions li.reacted {
    border-color: rgba(var(--movim-font), 0.3);
    box-sizing: border-box;
}

#chat_widget .bubble ul.reactions li img {
    width: 2.25rem;
    height: 3rem;
    margin: 0;
    padding: 0;
    margin-right: 0.5rem;
    order: 0;
}

/* File element */

li .bubble.file {
    margin-bottom: 1.5rem;
}

li .bubble.file div.file {
    margin-bottom: 3rem;
}

li:not(.oppose) .bubble.file span.resource + div.file {
    margin-top: 1rem;
}

li .bubble.file div.file img,
li .bubble.file div.file video {
    display: block;
    border-radius: 0.75rem;
    width: auto;
    max-height: 200px;
    margin-bottom: 1rem;
}

li div.bubble.file div.file img {
    max-height: 170px;
    min-width: 12rem;
    object-fit: cover;
    transition: opacity 0.2s ease-in-out;
    background-color: rgba(var(--movim-gray), 0.1);
    background-image: url(/theme/img/broken_image.svg);
    background-position: center;
    background-repeat: no-repeat;
}

li div.bubble.file video {
    max-height: 200px;
    background-color: rgba(var(--movim-font), 0.15);
    max-width: 100%;
}

li.oppose .bubble.file div.file img,
li.oppose .bubble.file div.file video {
    display: block;
    margin-right: 0;
    margin-left: auto;
}

li .bubble.file div.file[data-type="image/gif"]:after {
    color: white;
    font-family: 'Material Icons';
    text-shadow: 0 0 1rem rgba(0, 0, 0, 0.5);
    position: absolute;
    font-size: 5rem;
    line-height: 5rem;
    content: "\e908";
    top: 0;
    left: 0.5rem;
    display: block;
    pointer-events: none;
}

li .bubble.file div.file a span.host:before,
li .bubble.file div.file a span.size:before {
    content: '-';
    margin-left: 1rem;
    margin-right: 1rem;
}

/* Message Info */

#chat_widget .bubble .message span.info:after {
    display: inline-block;
    font-family: 'Material Icons';
    vertical-align: middle;
}

#chat_widget .bubble.file .message div.file:before {
    display: inline-block;
    position: absolute;
    top: 1rem;
    right: 1rem;
    font-family: 'Material Icons';
    color: white;
    text-shadow: 0 0 1rem rgba(0, 0, 0, 0.85);
}

#chat_widget .bubble.file .message.delivered div.file:before,
#chat_widget .bubble .message.delivered span.info:after {
    content: '\e5ca';
}

#chat_widget .bubble.file .message.displayed div.file:before,
#chat_widget .bubble .message.displayed span.info:after {
    content: '\e877';
}

#chat_widget .bubble .message.encrypted span.info:after {
    content: '\e897';
}

#chat_widget .bubble.file .message.edited.delivered div.file:before,
#chat_widget .bubble .message.edited.delivered span.info:after {
    content: '\e3c9  \e5ca';
}

#chat_widget .bubble .message.encrypted.delivered span.info:after {
    content: '\e897  \e5ca';
}

#chat_widget .bubble.file .message.edited.displayed div.file:before,
#chat_widget .bubble .message.edited.displayed span.info:after {
    content: '\e3c9  \e877';
}

#chat_widget .bubble .message.encrypted.displayed span.info:after {
    content: '\e897  \e877';
}

#chat_widget .bubble.file .message span.info:after {
    display: none;
}

/* Card */

#chat_widget .bubble ul.card.list {
    max-width: 45rem;
}

#chat_widget .bubble ul.card.list li span.primary:not(.thumb) {
    margin: 1rem 0;
}

#chat_widget .bubble ul.card.list li span.primary:not(.thumb) img {
    display: inline-block;
}

#chat_widget .bubble span.resource + ul.card.list li {
    margin-top: 0.5rem;
}

#chat_widget .bubble ul.card.list li {
    margin-bottom: 0.5rem;
}

#chat_widget .bubble ul.card.list .info {
    display: none;
}

#chat_widget li.oppose .bubble ul.card.list {
    float: right;
}

#chat_widget li.oppose .bubble ul.card.list + * {
    clear: both;
    display: block;
    text-align: right;
}

#chat_widget li .bubble ul.card.list + p {
    margin-right: 4.5rem;
    margin-bottom: 0.25rem;
}

/* Reply */

#reply:not(:empty) {
    margin: 0 0.5rem;
    border-top: 1px solid rgba(var(--movim-font), 0.12);
}

#reply li {
    padding: 0.5rem 0;
}

/* Counter */

#chat_widget #chatheadercounter .counter {
    margin-top: 1rem;
}


@media screen and (min-width: 1025px) {
    #chat_widget #chatheadercounter .counter {
        display: none;
    }
}

/* Parent scroll */

@keyframes backgroundblink {
    0%,
    50%,
    100% {
        opacity: 1;
    }

    25%,
    75% {
        opacity: 0.5;
    }
}

#chat_widget .bubble.scroll_blink {
    animation: backgroundblink 1s;
}
